// nejsevernejsi, nejjiznejsi, nejzapadnejsi, nejvyssi a nejnizsi kes v kraji

function MarginalCachesInRegion_AddDoubleRow(sLabel,sValue,sComment:string):string;
begin
  Result:='<tr style="%StyleTableNumTr%">'
    +'<td style="%StyleTableNumLabelTd%">'+sLabel+'&nbsp;</td>'
    +'<td style="%StyleTableNumTd%">'+sValue+'</td>'
    +'<td style="%StyleTableNumTd%">'+sComment+'</td></tr>'+CRLF;
end;

function MarginalCachesInRegion_Output(aPar:TStringList):string;
var 
  s,ss,sState,sStyle,sChm,sMarkers,sSql,sL,sV,sC,sBorder,sScale:string;
  iMapWidth,iMapHeight:integer;
  tab: TSqliteTable;
  ini:TMemIniFile;
begin
  sState:=aPar.Values['State'];
  // tabulka s kesemi
  Result:='<table style="%StyleTableNum%">'+CRLF
      +'<tr style="%StyleTableNumTr%"><th colspan=3 style="%StyleTableNumTh%">'
      +_('Most northerly, southerly, ... cache in')
      +' '+sState
      +'</th></tr>'+CRLF;
      
  //Nejsevernejsi kes
  sL:=_('Most northerly cache');
  sSql:='SELECT max(0+gc.x) coordx, gc.y coordy, gc.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''CZ kraj'' AND gtv.key=gt.ptrvalue'
    +'     AND gtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    sV:='<b>'+Fetch(s,' ')+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:blue|label:N|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Nejjiznejsi kes
  sL:=_('Most southerly cache');
  sSql:='SELECT min(0+gc.x) coordx, gc.y coordy, gc.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''CZ kraj'' AND gtv.key=gt.ptrvalue'
    +'     AND gtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    sV:='<b>'+Fetch(s,' ')+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:blue|label:S|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Nejzapadnejsi kes
  sL:=_('Most westerly cache');
  sSql:='SELECT min(0+gc.y) coordy, gc.x coordx, gc.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''CZ kraj'' AND gtv.key=gt.ptrvalue'
    +'     AND gtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    ss:=Fetch(s,' ');
    sV:='<b>'+s+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:blue|label:W|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Nejvychodnejsi kes
  sL:=_('Most easterly cache');
  sSql:='SELECT max(0+gc.y) coordy, gc.x coordx, gc.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''CZ kraj'' AND gtv.key=gt.ptrvalue'
    +'     AND gtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    ss:=Fetch(s,' ');
    sV:='<b>'+s+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:blue|label:E|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Nejvyssi kes nad morem
  sL:=_('Highest cache');
  sSql:='SELECT max(0.+gtv.value) mx, gc.y coordy, gc.x coordx, gt.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv, geotag sgt, geotagcategory sgtc, geotagvalue sgtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''Elevation'' AND gtv.key=gt.ptrvalue'
    +'     AND sgt.id=gc.id'
    +'     AND sgtc.key=sgt.ptrkat AND sgtc.value=''CZ kraj'' AND sgtv.key=sgt.ptrvalue'
    +'     AND sgtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id NOT IN ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+InsertThousSep(tab.FieldByName['mx'])+'</b>&nbsp;'+_('m a.s.l.');
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:yellow|label:H|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Nejnizsi kes nad morem
  sL:=_('Lowest cache');
  sSql:='SELECT min(0.+gtv.value) mx, gc.y coordy, gc.x coordx, gt.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv, geotag sgt, geotagcategory sgtc, geotagvalue sgtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''Elevation'' AND gtv.key=gt.ptrvalue'
    +'     AND sgt.id=gc.id'
    +'     AND sgtc.key=sgt.ptrkat AND sgtc.value=''CZ kraj'' AND sgtv.key=sgt.ptrvalue'
    +'     AND sgtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id NOT IN ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    sV:='<b>'+InsertThousSep(tab.FieldByName['mx'])+'</b>&nbsp;'+_('m a.s.l.');
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:yellow|label:L|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Nejstarsi kes
  sL:=_('Oldest cache');
  sSql:='SELECT min(0+gc.dthidden) dth, gc.y coordy, gc.x coordx, gc.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''CZ kraj'' AND gtv.key=gt.ptrvalue'
    +'     AND gtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatDateTime('d.m.YYYY',IntToDate(tab.FieldByName['dth'])); 
    sV:='<b>'+s+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:red|label:O|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Prvn nalezen ke
  sL:=_('Prvn nalezen ke');
  sSql:='SELECT min(0+10000*gc.dtfound+gc.dtfoundtime) dtf, gc.dtfound df, gc.y coordy, gc.x coordx, gc.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0 and gc.dtfoundtime>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''CZ kraj'' AND gtv.key=gt.ptrvalue'
    +'     AND gtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatDateTime('d.m.YYYY',IntToDate(tab.FieldByName['df']));  
    sV:='<b>'+s+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:green|label:F|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Posledn nalezen ke
  sL:=_('Posledn nalezen ke');
  sSql:='SELECT max(0+10000*gc.dtfound+gc.dtfoundtime) dtf, gc.dtfound df, gc.y coordy, gc.x coordx, gc.id cacheid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0 and gc.dtfoundtime>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''CZ kraj'' AND gtv.key=gt.ptrvalue'
    +'     AND gtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatDateTime('d.m.YYYY',IntToDate(tab.FieldByName['df']));  
    sV:='<b>'+s+'</b><br>';
    sC:=MakeHtmlShortCacheInfoFromId(tab.FieldByName['cacheid']);
    sMarkers:=sMarkers+'&markers=color:green|label:L|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
  Result:=Result+MarginalCachesInRegion_AddDoubleRow(sL,sV,sC);

  //Prumer nalezu
  sL:=_('Prmr nalezench ke');
  sSql:='SELECT avg(0+gc.y) coordy, avg(0+gc.x) coordx, round(avg(0.+gtv.value),1) mx'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv, geotag sgt, geotagcategory sgtc, geotagvalue sgtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''Elevation'' AND gtv.key=gt.ptrvalue'
    +'     AND sgt.id=gc.id'
    +'     AND sgtc.key=sgt.ptrkat AND sgtc.value=''CZ kraj'' AND sgtv.key=sgt.ptrvalue'
    +'     AND sgtv.value="'+sState+'" '+SetSqlFilter(aPar);
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id NOT IN ('+sIgnoreCaches+')';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=FormatCoordNum(StrToFl(tab.FieldByName['coordx']),StrToFl(tab.FieldByName['coordy'])); 
    sV:='<b>'+InsertThousSep(tab.FieldByName['mx'])+'</b>&nbsp;'+_('m a.s.l.');
    sC:='<b>'+Fetch(s,' ')+' '+s+'</b><br>';
    sMarkers:=sMarkers+'&markers=color:black|'+tab.FieldByName['coordx']+','+tab.FieldByName['coordy'];
  finally
    tab.Free();
  end;
//  Result:=Result+MarginalCachesAll_AddDoubleRow(sL,sV,sC);

  // konec tabulky
  Result:=Result+CRLF+'</table>'+CRLF;

  if(aPar.Values['ShowMap']<>'Yes') then exit;
  
  // mapa
  if aPar.Values['Border']='Yes' then 
    sBorder:='border:1px solid #7B7B7B'
  else
    sBorder:='border:1px solid #'+GlobalVarGetColor('ColorMainBkg','FFFFFF');
  s:=aPar.Values['MapStyle']; 
  sStyle:=Fetch(s,'-');
  ini:=TMemIniFile.Create(GetModulesDir()+'MapPinboard.Style.ini');
  try
    sChm:=ini.ReadString(sStyle,'Style',sStyle);
  finally
    ini.Free();
  end;

  iMapWidth:=iWidth-2;         //misto na ramecek
  iMapHeight:=round(480.0*iMapWidth/640);
  if iMapWidth>640 then sScale:='2' else sScale:='1';

  Result:=Result
      +'<div style="margin-top:10px; line-height:0; '+sBorder+'">'
      +'<img width="'+IntToStr(iMapWidth)+'" height="'+IntToStr(iMapHeight)+'" '
      +'src="https://maps.google.com/maps/api/staticmap?size=640x480'
      +'&scale='+sScale+sChm+sMarkers+'" ></div>';
end;

// hlavni funkce modulu
function MarginalCachesInRegion_Run(aPar:TStringList):string;
var 
  s,sState,sSql,sOrder:string;
  i:integer;
  aStates,aPom:TStringList;
  tab: TSqliteTable;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);

  s:=aPar.Values['SortBy']; sOrder:=Fetch(s,'-');
  if(sOrder='Finds') then sOrder:=sOrder+' DESC, State';

  s:=aPar.Values['State']; sState:=Fetch(s,'-');
  if (sState='All') or (sState='Switch') then begin
    // pripravime seznam zemi
    aStates:=TStringList.Create();
    sSql:='SELECT gtv.value State, count(*) Finds'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND gc.country = "Czechia"'
    +'     AND gc.dtfound>0'+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''CZ kraj'' AND gtv.key=gt.ptrvalue'+SetSqlFilter(aPar);
    if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
    sSql:=sSql+' GROUP BY gtv.value ORDER BY '+sOrder;
    tab:=Geoget_DB.GetTable(sSql,false);
    try
      while not tab.eof do begin
        aStates.Add(tab.FieldByName['State']);
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    // prepinaci logika
    if sState='Switch' then begin
      aPom:=TStringList.Create();
      try
        for i:=0 to aStates.Count-1 do begin
          s:=aStates[i];
          aPom.Add(s); //text na tlacitko
          aPom.Add('i-'+IntToStr(iItem)+'-'+IntToStr(i)); //prepinany element
        end;  
        Result:=Result+OutputSwitchButtons(IntToStr(iItem),aPar.Values['SwitchType'],5,true,aPom);
      finally
        aPom.Free();
      end;
    end;
    // vystup pro vsechny zeme
    for i:=0 to aStates.Count-1 do begin
      if sState='Switch' then begin
        Result:=Result+'<div id="i-'+IntToStr(iItem)+'-'+IntToStr(i)+'"';
        if i<>0 then Result:=Result+' style="display:none;"';
        Result:=Result+'>';
      end;
      aPar.Values['State']:=aStates[i];
      Result:=Result+MarginalCachesInRegion_Output(aPar);  
      if sState='Switch' then Result:=Result+'</div>';
      if sState='All' then Result:=Result+'<div style="margin-bottom:25px"></div>';  
    end;
    aStates.Free();
  end else begin
    Result:=Result+MarginalCachesInRegion_Output(aPar);  
  end;
end;